/*
 * Ejercicio1.java
 *
 * Creado el 13 de diciembre de 2005, 10:46
 */


package computacion.practica3;
import auxiliar.*;

/**
 * La ecuacin e^{-x^2} - cos x = 0 tiene una solucin en  x = 0.  La funcin
 * de la izquierda admite la expresin en serie de potencias 
 *   e^{-x^2} - cos x = - (1/1!-1/2!)x^2 + (1/2!-1/4!)x^4 - (1/3!-1/6!)x^6
 *                      + (1/4!-1/8!)x^8 + ...,
 * lo que significa que no tiene ceros en el intervalo (0,1] (la serie es 
 * alternada y la sucesin de sus trminos es decreciente en valor absoluto,
 * con lo que e^{-x^2} - cos x tiene el signo del primer sumando, es decir,
 *   e^{-x^2} - cos x < 0 
 * para cada x en (0,1]). Dado que 
 *   e^{-1^2} < cos 1, e^{-(PI/2)^2} > cos PI/2,
 * la ecuacin e^{-x^2} - cos x = 0 ha de tener al menos un cero en el intervalo
 * (1, PI/2). Como la derivadas de e^{-x^2}  y cos x son respectivamente
 * decreciente y creciente en dicho intervalo, habr exactamente un cero de la 
 * ecuacin en [1, PI/2], que ser la menor raz positiva de la misma. 
 * En nuestros mtodos numricos tomaremos los extremos de dicho intervalo como 
 * puntos de partida para  obtener dicho cero.
 *
 * La ecuacin senh x - sen x = 0 tiene a 0 como su nica raz. La razn es que 
 * la expresin en serie de potencias de senh x - sen x es
 *   senh x - sen x = x + x^3/3! + x^5/5! + x^7/7! + x^9/9! + x^{11}/11! + ...
 *                  -(x - x^3/3! + x^5/5! - x^7/7! + x^9/9! - x^{11}/11! + ...)
 *                  = 2(x^3/3! + x^7/7! + x^{11}/11! + ...),
 * de modo que 
 *   senh x - sen x > 0
 * si x > 0 y 
 *   senh x - sen x < 0
 * si x < 0.
 *
 * La ecuacin e^x + 2^{-x} + 2 cos x - 12 = 0 tiene una raz negativa. La
 * razn es que claramente la funcin de la izquierda es negativa para cada 
 * -2 <= x <= 0, y es decreciente para valores menores que -2. En particular,
 * como la funcin toma valores positivos para x = -4, concluimos que la 
 * nica raz est en el intervalo [-4, -2].
 *
 *
 * @author vjimenez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio1 {
    
    public static void main(String[] args) {
        FuncionEj1a f = new FuncionEj1a();
        FuncionEj1b g = new FuncionEj1b();
        FuncionEj1c h = new FuncionEj1c();        
        double cero;
        
        try {
            System.out.println();
            System.out.println("Mtodo de la biseccin para f en [1, PI/2]:");
            cero = MetodosIterativos.biseccion(f, 1, Math.PI / 2, 1E-11, 100);
            System.out.println();
            System.out.println("Mtodo de la Regula Falsi modificado para f"
                    + " en [1, PI/2]:");
            cero = MetodosIterativos.regulaFalsiModificado(f, 1, Math.PI / 2, 
                    1E-11, 100);
            System.out.println();
            System.out.println("Mtodo de Newton para f empezando en 1:");
            cero = MetodosIterativos.newton(f, 1, 1E-11, 100);
            System.out.println();
            System.out.println("Mtodo de Newton para f empezando en PI/2:");
            cero = MetodosIterativos.newton(f, Math.PI / 2, 1E-11, 100);
            System.out.println();
        } catch(MetodosIterativos.ErrorMetodosIterativos noconverge) {
        }
        
        try {   
            System.out.println();
            System.out.println("Mtodo de Newton para g empezando en 0:");
            cero = MetodosIterativos.newton(g, 0, 1E-11, 100);
            System.out.println();
            System.out.println("Mtodo de Newton para g empezando en 10:");
            cero = MetodosIterativos.newton(g, 10, 1E-11, 100);  
            System.out.println();
            System.out.println("Mtodo de la Regula Falsi modificado para g"
                    + " en [-2, 3]:");
            cero = MetodosIterativos.regulaFalsiModificado(g, -2, 3, 1E-11, 100);            
            System.out.println();
            System.out.println("Mtodo de la biseccin para g en [-2, 3]:");
            cero = MetodosIterativos.biseccion(g, -2, 3, 1E-11, 100);
        } catch(MetodosIterativos.ErrorMetodosIterativos noconverge) {
        }             
                
        try {   
            System.out.println();
            System.out.println("Mtodo de Newton para h empezando en 2:");
            cero = MetodosIterativos.newton(h, -2, 1E-11, 100);
            System.out.println();
            System.out.println("Mtodo de la Regula Falsi modificado para h"
                    + " en [-4, -2]:");
            cero = MetodosIterativos.regulaFalsiModificado(h, -4, -2, 1E-11, 100);            
            System.out.println();
            System.out.println("Mtodo de la biseccin para h en [-4, -2]:");
            cero = MetodosIterativos.biseccion(h, -4, -2, 1E-11, 100);
        } catch(MetodosIterativos.ErrorMetodosIterativos noconverge) {
        }     
        
    }
        
}
